var extTree;

function initNavigation() {
	var Tree = Ext.tree;
	
	var tree = new Tree.TreePanel({
		el:'drevo',
		animate:false, 
		loader: new Tree.TreeLoader(),
		enableDD:true,
		containerScroll: true
	});
	tree.on('textchange', function(node, text, old) {
		//alert(node.id + ' changed text "' + old + '" to "' + text + '"');
	});
	extTree = tree;
	
    treeEditor = new Tree.TreeEditor(tree, new Ext.form.Field({
        cancelOnEsc:true,
        completeOnEnter:true,
        ignoreNoChange:true        
    }));
	  
	// set the root node
	var root = new Tree.TreeNode({
		text: 'Root',
		draggable:false,
		id:'rott',
		expanded:true
	});
	tree.setRootNode(root);
	//extTreeRoot = root;
	
	tree.render();
	root.expand(false, /*no anim*/ false);
}

function addNode(id, title) {
	var t = extTree;
	var child = new Ext.tree.TreeNode({
		text: title,
		draggable:true,
		allowDrop: false,
		id:'n'+id,
		expanded:true
	});
	
	child.on('click', onNodeClick);
	child.on('contextmenu', showContextMenu);
	child.on('move',onNodeMove);
	
	t.getRootNode().appendChild(child);
}

function onNodeClick() {
	var id = String(this.id).substr(1);
	select(id);
}

function onSubNodeClick() {
	var snid = String(this.id);
	var id = snid.substr(0, snid.indexOf('_'));
	select(id);
}

function addSubNode(id, subNodeId, title) {
	var parent = extTree.getNodeById('n'+id);
	if (parent==null) return;
	var child = new Ext.tree.TreeNode({
			text: title,
			draggable:false,
			allowDrop:false,
			id: subNodeId
		});
	child.on('click', onSubNodeClick);

	parent.appendChild(child);
}


function onNodeMove(tree, node, oldParent, newParent, index) {
	if (newParent!=oldParent) return false;
	var id = String(node.id).substr(1);
	var div = Ext.get('c'+id);
	var divClass = div.dom.className;
	var divHtml = div.dom.innerHTML;
	div.remove();
	
	var prev = newParent.item(index-1);
	if (prev==null) {
		// gre na prvo mesto
		var before = newParent.item(index+1);
		var divId = 'c'+String(before.id).substr(1);
		var newDiv = Ext.DomHelper.insertBefore(divId, { tag: 'div', id: 'c'+id, cls: divClass }, true);
	} else {
		var divId = 'c'+String(prev.id).substr(1);
		var newDiv = Ext.DomHelper.insertAfter(divId, { tag: 'div', id: 'c'+id, cls: divClass }, true);
	}
	newDiv.dom.innerHTML = divHtml;
	newDiv.on('click', onDivClick);
}

function showContextMenu(node, e) {
	//alert(this.text);
	//alert(this.attributes.type);
	var menu = initContextMenu(node);
	if(menu.items.length>0)	// show only if menu has any items
		menu.showAt(e.getXY());
	e.stopEvent();
}

function initContextMenu(node) {
	var menu = new Ext.menu.Menu({
		id: 'cm_'+node.id
	});

	var menuItem = new Ext.menu.Item({ icon:'images/pop-ico-edit.png' });
	menuItem.setText('Dodaj komentar');
	menuItem.addListener('click', onAddCommentClick, node);	
	menu.addItem(menuItem);
	
	var menuItem = new Ext.menu.Item({ icon:'images/pop-ico-delete.png' });
	menuItem.setText('Izbriši');
	menuItem.addListener('click', deleteNode, node);	
	menu.addItem(menuItem);
	/*
	if (item['title']=='-') { menu.addSeparator(); continue; }
	var menuItem = new Ext.menu.Item({ icon:'resources/images/'+item['icon'], cls:'x-btn-icon'} );
	menuItem.setText(item['title']);
	var fnOnClick = getOnClickForNode(node, item);
	menuItem.addListener('click', fnOnClick, node);
	menu.addItem(menuItem);
	*/

	return menu;
}

function onAddCommentClick(e) {
	var id = String(this.id).substr(1);
	var parent = extTree.getNodeById('n'+id);
	if (parent==null) return;

	var children = parent.childNodes;
	// calculate commendID
	var cid = 1;
	if (children!=null) {
		for (var i=0; i<children.length; i++) {
			var cs = String(children[i].id);
			if (cs.substr(0,1)=='c')  {
				var oldCid = cs.substr(cs.indexOf('_')+1);
				cid = parseInt(oldCid) + 1;
			}
		}
	}
	var commentId = 'cmt'+id + '_' + cid;
	var child = new Ext.tree.TreeNode({
		text: 'komentar',
		draggable:false,
		allowDrop:false,
		id: commentId,
		icon: 'images/comment.png',
		cls: 'x-btn-icon'
	});
	child.on('click', onCommentNodeClick);

	parent.appendChild(child);
	
	addCommentDiv(commentId);
}


function onCommentNodeClick() {
	var commentId = this.id;
	var divId = commentId.substr(3, commentId.indexOf('_')-3);
	select(divId);	
}

function deleteNode(e) {
	//alert('brisi node ' + this.id);
	var id = String(this.id).substr(1);
	//alert(id);
	deleteDiv(id);
	this.remove();
}



function debugObject(o, hidenulls) {
	var s = '';
	var j = 0;
	for(var i in o) {
		if (typeof o[i] != 'function' && !(hidenulls && o[i]==null)) {
			j++;
			s += i+'='+o[i];
			if (j % 2 == 0) s+="\n"; else s+="  |||  ";
		}
	}
	alert(s);
}
